'------------------------------------------	
'Figure 1 Inputs
'------------------------------------------
!T=300
!reps=10000
!points=!T/2-1
wfcreate u 1 !T
!w=@acos(-1)/2 'Frequency in radians
mode quiet
'Variance covariance matrix
scalar s1=@sqrt(0.5) 'Variance
scalar s2=@sqrt(0.5) 'Variance
scalar rho=0.2/@sqrt(0.5*0.5) 'Covariance
'------------------------------------------
matrix(!points,!reps) statistic
for !i=1 to !reps
	series e1=0
	series e2=0
	call nrn(e1,e2,s1,s2,rho)
	genr y=0
	genr x=0
	for !j=4 to !T
		x(!j)=0.1*x(!j-1)+0.3*(y(!j-1)-2*@cos(!w)*y(!j-2)+y(!j-3))+e1(!j) 
		y(!j)=-x(!j-1)+0.1*y(!j-1)-0.2*y(!j-2)+0.3*y(!j-3)+e2(!j)
	next
	smpl @all
	speccaus(variables=x y,slag=3) 
	for !j=1 to !points
		statistic(!j,!i)=data(!j+1,2)
	next
	d data causality
	statusline !i
next

!loop=0
vector(!points) size
for !i=1 to !points
	for !j=1 to !reps
		if statistic(!i,!j)<0.05 then
			!loop=!loop+1
		endif
	next
	size(!i)=!loop/!reps
	!loop=0
next
!end= !T/2-1
smpl 1 !end
genr w=@acos(-1)*@trend/(!T/2-1)
mtos(size,size_power)
group g1 w size_power
g1.xyline
subroutine local nrn(series e1,series e2,scalar sigma1,scalar sigma2,scalar rho)
	e1 = sigma1*nrnd
	e2 = sigma2*(rho*e1/sigma1 + @sqrt(1-rho^2)*nrnd)
endsub


