'------------------Testing for short and long run causality. A frequency domain approach--------------------
%varlist=@equaloption("variables")
%lag__crit=@equaloption("maxlags")
%ex=@equaloption("exogenous")
%user_lag=@equaloption("slag")
if @hasoption("AIC") then
	%crit="AIC"
endif
if @hasoption("SC") then
	%crit="SC"
endif
if @hasoption("HQ") then
	%crit="HQ"
endif
if @hasoption("FPE") then
	%crit="FPE"
endif
if %lag__crit="" then
	%lag__crit="12"
endif
if %crit="" then
	%crit="AIC"
endif
if @hasoption("c") then
	scalar coint=1
	else
	scalar coint=0
endif
if @hasoption("fs") then
	scalar fs=1
	else
	scalar fs=0
endif
if @hasoption("e") then
	scalar e=1
	else
	scalar e=0
endif
if %varlist="" then
	%varlist=""
	scalar crit_lag=1
	if coint<>1 then
		scalar coint=0
	endif
	if e<>1 then
		scalar e=0
	endif
	%lag__crit="12"
	!result=@uidialog("edit",%varlist,"Endogenous variables:",64,"edit",%ex,"Exogenous variables:",64,"radio",crit_lag,"Lag selection criteria for the VAR(p)","""Akaike"" ""Schwartz"" Hannan-Quinn FPE","edit",%lag__crit,"Maximum Lags:","edit",%user_lag,"User Specified Lag:","check",coint,"Cointegrated variables","check",e,"Save VAR estimates","check",fs,"Save F statistical","caption","Frequency Domain Causality","text","                                                                                                                        Written by: Nicolas Ronderos (2016)")
	if !result=-1 then
		delete crit_lag coint e
		stop
	endif
	if crit_lag=1 then
		%crit="AIC"
	endif
	if crit_lag=2 then
		%crit="SC"
	endif
	if crit_lag=3 then
		%crit="HQ"
	endif
	if crit_lag=4 then
		%crit="FPE"
	endif
	delete crit_lag
endif
!lag_crit=@val(%lag__crit)
'--------------------------------------------------------------------------------------------------------------------------------------

if coint=0 then
	var var_
	var_.ls 1 2 {%varlist} @ c {%ex}
	freeze(criteria) var_.laglen(!lag_crit)
	matrix(!lag_crit+1,1) crit
	for !i=1 to 7
		if criteria(8,!i)=%crit then
			for !j=1 to !lag_crit+1
				if @val(criteria(9+!j,!i))="" then
					!lag=!j-1
				endif
			next
		endif
	next
	if !lag<=2 then
		@uiprompt("VAR(0),VAR(1) or VAR(2),the test can not be performed")
		d coint crit criteria e var_
		stop
	endif
	if %user_lag="" then
			!lag=!lag
		else
			!lag=@val(%user_lag)
	endif
	for !j=1 to @wcount(%varlist)
		string list_!j=""
		for !i=1 to !lag
			string list_!j=list_!j+@word(%varlist,!j)+"(-"+@str(!i)+") "
		next
		%list=%list+" "+list_!j
	next
	for !i=1 to @wcount(%varlist)
		%dep=@word(%varlist,!i)
		equation ec_!i.ls {%dep} c {%list} {%ex}
		scalar s2_!i=@se^2
		for !j=1 to (!lag)*@wcount(%varlist)+@wcount(%ex)+1
			vector(!lag*@wcount(%varlist)+@wcount(%ex)+1) beta_!i(!j)=c(!j)
		next
	next
	%varm= "fd_var"
	if @isobject(%varm) then 
		%varm=@getnextname(%varm)
	endif
	var {%varm}
	{%varm}.ls 1 !lag {%varlist} @ c {%ex}
else
	if %crit="HQ" or %crit="FPE" then
		@uiprompt("With cointegrated variables are only available the AIC or the SC criteria")
		delete coint e
		stop
	endif
	%dvarlist=""
	for !i=1 to @wcount(%varlist)
		%dvarlist=%dvarlist+" d("+@word(%varlist,!i)+") "
	next
	%list_=""
	var var_
	for !j=1 to !lag_crit
		for !i=1 to @wcount(%varlist)
			%list_=%list_+@word(%varlist,!i)+"(-"+@str(!j)+") "
		next
		var_.ls 0 0 {%dvarlist} @ c {%list_} {%ex}
		vector(!lag_crit) info(!j)=var_.@{%crit}
	next
	!lag=@cimin(info)
	if !lag<=2 then
		@uiprompt("VAR(0),VAR(1) or VAR(2),the test can not be performed")
		d coint e var_ info
		stop
	endif
	if %user_lag="" then
			!lag=!lag
		else
			!lag=@val(%user_lag)
	endif
	%list_=""
	for !i=1 to @wcount(%varlist)
		for !j=1 to !lag
			%list_=%list_+@word(%varlist,!i)+"(-"+@str(!j)+") "
		next
	next
	for !i=1 to @wcount(%varlist)
		%dep=@word(%dvarlist,!i)
		equation ec_!i.ls {%dep} c {%list_} {%ex}
		scalar s2_!i=@se^2
		for !j=1 to (!lag)*@wcount(%varlist)+@wcount(%ex)+1
			vector(!lag*@wcount(%varlist)+@wcount(%ex)+1) beta_!i(!j)=c(!j)
		next
	next
	%varm= "fd_var"
	if @isobject(%varm) then 
		%varm=@getnextname(%varm)
	endif
	var {%varm}
	{%varm}.ls 0 0{%dvarlist} @ c {%list_} {%ex}
endif

for !i=1 to @wcount(%varlist)+@wcount(%ex)
	if !i<=@wcount(%varlist) then
		%var=@word(%varlist,!i)
		else
		%var=@word(%ex,!i-@wcount(%varlist))
	endif
	vector(@wcount(%varlist)+@wcount(%ex)) obs(!i)=@obs({%var})
next
!n=@min(obs)

!pi=@acos(-1)
for !i=1 to @floor(!n/2) ' Excluye frecuencia cero
	!q=!i
	if !i=@floor(!n/2) and !n/2<>@floor(!n/2) then
		!q=(!n-1)/2
	endif
	vector(@floor(!n/2),1) w(!i,1)=(2*!pi*!q)/!n
next

for !i=1 to @wcount(%varlist)
	matrix(@floor(!n/2),!lag*@wcount(%varlist)+@wcount(%ex)+1) cosine_!i=0
next
for !v=1 to @wcount(%varlist)
	for !i=1 to @floor(!n/2)
		for !j=1 to !lag
			!c=!j+1+!lag*(!v-1)
			matrix(@floor(!n/2),!lag*@wcount(%varlist)+@wcount(%ex)+1) cosine_!v(!i,!c)=@cos(w(!i)*!j)
			matrix(@floor(!n/2),!lag*@wcount(%varlist)+@wcount(%ex)+1) sine_!v(!i,!c)=@sin(w(!i)*!j)
		next
	next
next

genr cons=1
if coint=0 then
	group variables cons {%list} {%ex}
else
	group variables cons {%list_} {%ex}
endif
stom(variables,mvar)


for !j=1 to @wcount(%varlist)
	for !v=1 to @wcount(%varlist)
		if !j<>!v then
			for !i=1 to @floor(!n/2)-1 'Excluye la frecuencia pi
				for !l=1 to !lag*@wcount(%varlist)+@wcount(%ex)+1
					matrix(2,!lag*@wcount(%varlist)+@wcount(%ex)+1) cos_sin(1,!l)=cosine_!v(!i,!l)
					matrix(2,!lag*@wcount(%varlist)+@wcount(%ex)+1) cos_sin(2,!l)=sine_!v(!i,!l)
				next
				scalar F=(@transpose(cos_sin*beta_!j)*@inverse((cos_sin*s2_!j*@inverse(@transpose(mvar)*mvar)*@transpose(cos_sin)))*cos_sin*beta_!j)/2
				vector(!n/2-1) f_!j_!v(!i)=F 'H0: Variable v no causa a variable j
			next
		endif
	next
next

mtos(w,omega)
group output
for !i=1 to @wcount(%varlist)
	for !j=1 to @wcount(%varlist)
		if !i<>!j then
			%var1=@word(%varlist,!i)
			%var2=@word(%varlist,!j)
			mtos(f_!i_!j,{%var1}_{%var2})
			!t=@rows(mvar)
			{%var1}_{%var2}=@fdist({%var1}_{%var2},2,!t-@wcount(%varlist)*!lag-@wcount(%ex)-1)
			group output output omega {%var1}_{%var2}
		endif
	next
next

%table= "Data"
if @isobject(%table) then 
	%table=@getnextname(%table)
endif

!loop=1
for !i=1 to @wcount(%varlist)
	for !j=1 to @wcount(%varlist)
		if !i<>!j then
			%var1=@word(%varlist,!i)
			%var2=@word(%varlist,!j)
			!loop=!loop+1
			table {%table}(1,1)="Angular frequency"
			table {%table}(1,!loop)=@word(%varlist,!j)+" No Cause-Granger "+@word(%varlist,!i)
			!first=@ifirst({%var1}_{%var2})
			for !k=1 to @floor(!n/2)-1
				table {%table}(!k+1,1)=omega(!k+!first-1)
				table {%table}(!k+1,!loop)={%var1}_{%var2}(!k+!first-1)
			next
		endif
	next
next
{%table}.setwidth(@all) 28
{%table}.setheight(1) 2
{%table}.setfillcolor(1) @rgb(9, 79, 164)
{%table}.settextcolor(1) white
{%table}.setlines(@all) +a
{%table}.label(r) Author of the program: Nicolas Ronderos Pulido.

%grafico = "Causality"
if @isobject(%grafico) then 
	%grafico = @getnextname(%grafico)
endif
freeze({%grafico}) output.xypairs(m)
%lag=@str(!lag)
%dg=@str(!t-@wcount(%varlist)*!lag-@wcount(%ex)-1)
{%grafico}.addtext(t,pt=20) Causality in the frequency domain | H0: There is not causality at frequency Omega | P-value D.F. (2,{%dg}) | Selected lag: {%lag} | Exogenous variables: c {%ex}
{%grafico}.axis(l) range(0,1)
{%grafico}.options gridl

if coint=0 then
	for !i=1 to @wcount(%varlist)
		delete ec_!i list_!i s2_!i beta_!i cosine_!i sine_!i
		for !j=1 to @wcount(%varlist)
			if !i<>!j then
				%var1=@word(%varlist,!i)
				%var2=@word(%varlist,!j)
				if fs=0 then
				delete f_!i_!j {%var1}_{%var2}
				endif
			endif
		next
	next
	delete cos_sin crit criteria f obs omega output  variables w mvar cons coint var_ fs
else
	for !i=1 to @wcount(%varlist)
		delete ec_!i s2_!i beta_!i cosine_!i sine_!i
		for !j=1 to @wcount(%varlist)
			if !i<>!j then
				%var1=@word(%varlist,!i)
				%var2=@word(%varlist,!j)
				if fs=0 then
				delete f_!i_!j {%var1}_{%var2}
				endif
			endif
		next
	next
	delete cos_sin f obs omega output  variables w mvar cons coint info var_ fs
endif

if e=0 then
	delete {%varm}
endif
delete e

